package simplygroovy.sql.stats

import simplygroovy.sql.query.Aggregate
import simplygroovy.util.MapUtil

/**
 * Created: 20/06/11
 * @author david
 */
class AggregateStats {
    private Map<String, Object> columns = [:]
    private Map<Integer, Double> percentiles = [:]
    int precisionOfPercentileKey = 0
    Double average
    Double min
    Double max
    Double stdDevPop
    Double stdDevSample
    Double sum
    Integer count

    public AggregateStats add(String column, Object value) {
        columns[column] = value
        return this
    }

    public Object get(String column) {
        return columns[column]
    }

    public Set<String> columnNames() {
        return columns.keySet()
    }

    public Double getPercentile(double percentile) {
        return percentiles[getKey(percentile)]
    }

    public void setPercentile(double percentile, Double value) {
        percentiles[getKey(percentile)] = value
    }

    private Integer getKey(double percentile) {
        MapUtil.doubleKey(percentile, precisionOfPercentileKey)
    }
}
